/***************************************************************
 * Name:      RotTriangMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    A.V.Zelen (alvlzel@mail.ru)
 * Created:   2018-04-26
 * Copyright: A.V.Zelen ()
 * License:
 **************************************************************/

#include "RotTriangMain.h"
#include <wx/msgdlg.h>
#include <wx/dcclient.h>
#include <wx/pen.h>
#include <wx/brush.h>
#include <wx/colour.h>
#include <wx/event.h>
#include <math.h>

//(*IdInit(RotTriangFrame)
const long RotTriangFrame::ID_PANEL2 = wxNewId();
const long RotTriangFrame::ID_BUTTON1 = wxNewId();
const long RotTriangFrame::ID_BUTTON2 = wxNewId();
const long RotTriangFrame::ID_PANEL1 = wxNewId();
const long RotTriangFrame::idMenuQuit = wxNewId();
const long RotTriangFrame::idMenuAbout = wxNewId();
const long RotTriangFrame::ID_STATUSBAR1 = wxNewId();
const long RotTriangFrame::id_dc = wxNewId();
const long RotTriangFrame::id_PenBlue = wxNewId();
const long RotTriangFrame::id_PenGreen = wxNewId();
const long RotTriangFrame::id_PenBlack = wxNewId();
const long RotTriangFrame::id_Brush = wxNewId();
//*)

bool log1tRotate=TRUE,logStop=TRUE;
int R,Xc,Yc;
int x[7],y[7],Xu,Yu;
int Xn[7],Yn[7],Xn_old[7],Yn_old[7];
float Alf,Au[3];

BEGIN_EVENT_TABLE(RotTriangFrame,wxFrame)
    //(*EventTable(RotTriangFrame)
    //*)
END_EVENT_TABLE()

RotTriangFrame::RotTriangFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(RotTriangFrame)
    wxFlexGridSizer* FlexGridSizer1;
    wxMenu* Menu1;
    wxMenu* Menu2;
    wxMenuBar* MenuBar1;
    wxMenuItem* MenuItem1;
    wxMenuItem* MenuItem2;

    Create(parent, id, _("Rotating triangle"), wxDefaultPosition, wxDefaultSize, wxCAPTION|wxSYSTEM_MENU|wxCLOSE_BOX|wxMINIMIZE_BOX|wxSTATIC_BORDER, _T("id"));
    SetClientSize(wxSize(520,350));
    Panel2 = new wxPanel(this, ID_PANEL2, wxPoint(1,1), wxSize(416,305), wxTAB_TRAVERSAL, _T("ID_PANEL2"));
    Panel1 = new wxPanel(this, ID_PANEL1, wxPoint(418,1), wxSize(98,305), wxTAB_TRAVERSAL, _T("ID_PANEL1"));
    FlexGridSizer1 = new wxFlexGridSizer(2, 1, 0, 0);
    Button1 = new wxButton(Panel1, ID_BUTTON1, _("   Rotate   "), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    FlexGridSizer1->Add(Button1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button2 = new wxButton(Panel1, ID_BUTTON2, _("   Stop   "), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    FlexGridSizer1->Add(Button2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Panel1->SetSizer(FlexGridSizer1);
    SetSizer(FlexGridSizer1);
    Layout();
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    dc= new wxClientDC(Panel2);
    PenBlue= new wxPen(*wxBLUE,2,wxPENSTYLE_SOLID);
    PenGreen= new wxPen(*wxGREEN,1,wxPENSTYLE_SOLID);
    PenBlack= new wxPen(*wxBLACK,1,wxPENSTYLE_SOLID);
    Brush= new wxBrush(*wxBLACK);
    Center();

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&RotTriangFrame::OnButton1Click);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&RotTriangFrame::OnButton2Click);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&RotTriangFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&RotTriangFrame::OnAbout);
    //*)
}

RotTriangFrame::~RotTriangFrame()
{
    //(*Destroy(RotTriangFrame)
    //*)
}

void RotTriangFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void RotTriangFrame::OnAbout(wxCommandEvent& event)
{
    wxMessageBox(_("Press [Rotate] or/and [Stop]"), _("RT"));
}

void RotTriangFrame::OnButton1Click(wxCommandEvent& event)
{
 logStop=FALSE;
 RotateTriangle();
}

void RotTriangFrame::OnButton2Click(wxCommandEvent& event)
{
 logStop=TRUE;
}

void RotTriangFrame::RotateTriangle(void)
{
 void VychCoordOtUgla(void);
 void NormZnach(void);

 long lDelay;
 int iV,j;

 if(!log1tRotate) goto lab_C;

 dc->SetPen(*PenBlue); dc->SetBrush(*Brush);
 dc->DrawRectangle(5,3,300,295);

 R=100; Xc=150; Yc=150;
 Au[0]=0; Au[1]=120; Au[2]=240;

 log1tRotate=FALSE;

lab_C:

 while(!logStop) {

  for(iV=0;iV<3;iV++) {
   Alf=Au[iV]; VychCoordOtUgla();
   x[iV]=Xu; y[iV]=Yu; }
  NormZnach();

  dc->SetPen(*PenGreen);
  for(j=0;j<2;j++) dc->DrawLine(Xn[j],Yn[j],Xn[j+1],Yn[j+1]);
  dc->DrawLine(Xn[2],Yn[2],Xn[0],Yn[0]);

  for(j=0;j<3;j++) {
   Xn_old[j]=Xn[j]; Yn_old[j]=Yn[j]; }

  lDelay=500000; while((lDelay--)>0);
  dc->SetPen(*PenBlack);
  for(j=0;j<2;j++) dc->DrawLine(Xn_old[j],Yn_old[j],Xn_old[j+1],Yn_old[j+1]);
  dc->DrawLine(Xn_old[2],Yn_old[2],Xn_old[0],Yn_old[0]);
  Au[0]+=0.25; Au[1]+=0.25; Au[2]+=0.25;

  if(Au[0]>=120) { Au[0]=0; Au[1]=120; Au[2]=240; }
 }
}

void VychCoordOtUgla(void) {

 float getRadianFD(float Deg);

 float fXu, fYu;

 if(Alf<90) {
  fXu= R*sin(getRadianFD(Alf));
  fYu= R*cos(getRadianFD(Alf)); goto Lab_Evcu; }

 if(Alf<180) {
  Alf=Alf-90; fXu= R*cos(getRadianFD(Alf));
  fYu=-R*sin(getRadianFD(Alf)); goto Lab_Evcu; }

 if(Alf<270) {
  Alf=Alf-180; fXu=-R*sin(getRadianFD(Alf));
  fYu=-R*cos(getRadianFD(Alf)); goto Lab_Evcu; }

 if(Alf<360) {
  Alf=Alf-270; fXu=-R*cos(getRadianFD(Alf));
  fYu= R*sin(getRadianFD(Alf)); goto Lab_Evcu; }

 if(Alf>=360) { fXu=0; fYu=R; }

Lab_Evcu:
  Xu=(int)(fXu); Yu=(int)(fYu);
}

void NormZnach(void) {
 int i;
 for(i=0; i<3; i++) { Xn[i]=Xc+x[i]; Yn[i]=Yc-y[i]; }
}

float getRadianFD(float Deg)
{ return (Deg*M_PI)/180.0; }
