/***************************************************************
 * Name:      RotTriangMain.h
 * Purpose:   Defines Application Frame
 * Author:    A.V.Zelen (alvlzel@mail.ru)
 * Created:   2018-04-26
 * Copyright: A.V.Zelen ()
 * License:
 **************************************************************/

#ifndef ROTTRIANGMAIN_H
#define ROTTRIANGMAIN_H

//(*Headers(RotTriangFrame)
#include <wx/button.h>
#include <wx/frame.h>
#include <wx/menu.h>
#include <wx/panel.h>
#include <wx/sizer.h>
#include <wx/statusbr.h>
#include <wx/dcclient.h>
#include <wx/pen.h>
#include <wx/brush.h>
//*)

class RotTriangFrame: public wxFrame
{
    public:

        RotTriangFrame(wxWindow* parent,wxWindowID id = -1);
        virtual ~RotTriangFrame();

    private:

        //(*Handlers(RotTriangFrame)
        void OnQuit(wxCommandEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnButton1Click(wxCommandEvent& event);
        void OnButton2Click(wxCommandEvent& event);
        void RotateTriangle(void); // dobavil potom
        //*)

        //(*Identifiers(RotTriangFrame)
        static const long ID_PANEL2;
        static const long ID_BUTTON1;
        static const long ID_BUTTON2;
        static const long ID_PANEL1;
        static const long idMenuQuit;
        static const long idMenuAbout;
        static const long ID_STATUSBAR1;
        static const long id_dc;
        static const long id_PenBlue;
        static const long id_PenGreen;
        static const long id_PenBlack;
        static const long id_Brush;
        //*)

        //(*Declarations(RotTriangFrame)
        wxButton* Button1;
        wxButton* Button2;
        wxPanel* Panel1;
        wxPanel* Panel2;
        wxStatusBar* StatusBar1;
        wxClientDC* dc;
        wxPen* PenBlue;
        wxPen* PenGreen;
        wxPen* PenBlack;
        wxBrush* Brush;
        //*)

        DECLARE_EVENT_TABLE()
};

#endif // ROTTRIANGMAIN_H
